// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AppBar.pas' rev: 6.00

#ifndef AppBarHPP
#define AppBarHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Forms.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Appbar
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TAppBarFormHookComponent;
class PASCALIMPLEMENTATION TAppBarFormHookComponent : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool Hooked;
	bool FTopmost;
	Forms::TForm* FParentForm;
	unsigned FHHandle;
	unsigned FParentHandle;
	void *FOldWndProc;
	void *FNewWndProc;
	void __fastcall HookWndProc(Messages::TMessage &Message);
	int __fastcall GetWindowStyle(void);
	void __fastcall SetWindowStyle(int Value);
	int __fastcall GetWindowExStyle(void);
	void __fastcall SetWindowExStyle(int Value);
	
protected:
	virtual void __fastcall MessageBefore(Messages::TMessage &Message, bool &Handled);
	virtual void __fastcall MessageAfter(Messages::TMessage &Message);
	virtual void __fastcall FormRecreate(void);
	virtual void __fastcall WndProc(Messages::TMessage &Message);
	virtual unsigned __fastcall GetParentHandle(void);
	bool __fastcall GetTopmost(void);
	void __fastcall SetTopmost(bool Value);
	
public:
	__fastcall virtual TAppBarFormHookComponent(Classes::TComponent* aOwner);
	__fastcall virtual ~TAppBarFormHookComponent(void);
	void __fastcall RefreshNCArea(void);
	__property unsigned HHandle = {read=FHHandle, nodefault};
	__property Forms::TForm* ParentForm = {read=FParentForm, write=FParentForm};
	__property unsigned ParentHandle = {read=FParentHandle, nodefault};
	__property void * OldWndProc = {read=FOldWndProc};
	__property int WindowStyle = {read=GetWindowStyle, write=SetWindowStyle, nodefault};
	__property int WindowExStyle = {read=GetWindowExStyle, write=SetWindowExStyle, nodefault};
	__property bool Topmost = {read=GetTopmost, write=SetTopmost, nodefault};
	__property bool TopmostDesign = {read=FTopmost, nodefault};
};


class DELPHICLASS TAppBarAppHookComponent;
class PASCALIMPLEMENTATION TAppBarAppHookComponent : public TAppBarFormHookComponent 
{
	typedef TAppBarFormHookComponent inherited;
	
private:
	bool AppHooked;
	void *OldAppWndProc;
	void *NewAppWndProc;
	void __fastcall HookAppMessages(void);
	void __fastcall UnhookAppMessages(void);
	void __fastcall HookAppProc(Messages::TMessage &Message);
	
protected:
	virtual void __fastcall AppMessageBefore(Messages::TMessage &Message, bool &Handled);
	virtual void __fastcall AppMessageAfter(Messages::TMessage &Message);
	
public:
	__fastcall virtual TAppBarAppHookComponent(Classes::TComponent* aOwner);
	__fastcall virtual ~TAppBarAppHookComponent(void);
};


class DELPHICLASS TAppBarPersistent;
class DELPHICLASS TAppBar;
#pragma option push -b-
enum TAppBarPlacement { bpLeft, bpTop, bpRight, bpBottom, bpFloat };
#pragma option pop

typedef Set<TAppBarPlacement, bpLeft, bpFloat>  TAppBarEdges;

class DELPHICLASS TAppBarDocking;
class PASCALIMPLEMENTATION TAppBarPersistent : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FEnabled;
	TAppBar* FOwner;
	
public:
	__fastcall virtual TAppBarPersistent(TAppBar* aAppBar);
	__property TAppBar* Owner = {read=FOwner};
	
__published:
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=1};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TAppBarPersistent(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TAppBarDocking : public TAppBarPersistent 
{
	typedef TAppBarPersistent inherited;
	
private:
	Word FHeight;
	Word FWidth;
	Word FMaxHeight;
	Word FMaxWidth;
	Word FMinHeight;
	Word FMinWidth;
	void __fastcall SetHeight(Word Value);
	void __fastcall SetWidth(Word Value);
	
public:
	__fastcall virtual TAppBarDocking(TAppBar* aAppBar);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Word Height = {read=FHeight, write=SetHeight, default=32};
	__property Word Width = {read=FWidth, write=SetWidth, default=32};
	__property Word MaxHeight = {read=FMaxHeight, write=FMaxHeight, default=300};
	__property Word MaxWidth = {read=FMaxWidth, write=FMaxWidth, default=400};
	__property Word MinHeight = {read=FMinHeight, write=FMinHeight, default=0};
	__property Word MinWidth = {read=FMinWidth, write=FMinWidth, default=0};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TAppBarDocking(void) { }
	#pragma option pop
	
};


class DELPHICLASS TAppBarFloatRestrictions;
class PASCALIMPLEMENTATION TAppBarFloatRestrictions : public TAppBarPersistent 
{
	typedef TAppBarPersistent inherited;
	
private:
	Word FMaxWidth;
	Word FMaxHeight;
	Word FMinWidth;
	Word FMinHeight;
	void __fastcall SetMaxWidth(Word Value);
	void __fastcall SetMaxHeight(Word Value);
	void __fastcall SetMinWidth(Word Value);
	void __fastcall SetMinHeight(Word Value);
	void __fastcall UpdateFloatRestrictions(void);
	
public:
	__fastcall virtual TAppBarFloatRestrictions(TAppBar* aAppBar);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Enabled  = {default=0};
	__property Word MaxWidth = {read=FMaxWidth, write=SetMaxWidth, default=0};
	__property Word MaxHeight = {read=FMaxHeight, write=SetMaxHeight, default=0};
	__property Word MinWidth = {read=FMinWidth, write=SetMinWidth, default=0};
	__property Word MinHeight = {read=FMinHeight, write=SetMinHeight, default=0};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TAppBarFloatRestrictions(void) { }
	#pragma option pop
	
};


class DELPHICLASS TAppBarRegistrySaver;
#pragma option push -b-
enum TAppBarRegLocation { rlCurrentUser, rlLocalMachine };
#pragma option pop

#pragma option push -b-
enum TAppBarRestoreProperty { rpAllowedEdges, rpFormSize, rpDocking, rpFloatRestrictions, rpSizing, rpSliding };
#pragma option pop

typedef Set<TAppBarRestoreProperty, rpAllowedEdges, rpSliding>  TAppBarRestoreProperties;

#pragma option push -b-
enum AppBar__8 { saveOnClose, saveOnMoveResize };
#pragma option pop

typedef Set<AppBar__8, saveOnClose, saveOnMoveResize>  TAppBarRegOptions;

#pragma option push -b-
enum TAppBarStorageType { useRegistry, useIniFile };
#pragma option pop

class PASCALIMPLEMENTATION TAppBarRegistrySaver : public TAppBarPersistent 
{
	typedef TAppBarPersistent inherited;
	
private:
	AnsiString FIniFileName;
	AnsiString FIniSection;
	TAppBarRegLocation FRegLocation;
	AnsiString FRegKey;
	TAppBarRestoreProperties FRestoreProperties;
	TAppBarRegOptions FOptions;
	TAppBarStorageType FStorage;
	void __fastcall SetRegLocation(TAppBarRegLocation Value);
	void __fastcall SetRegKey(AnsiString Value);
	
public:
	__fastcall virtual TAppBarRegistrySaver(TAppBar* aAppBar);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Load(void);
	void __fastcall Save(void);
	
__published:
	__property Enabled  = {default=0};
	__property AnsiString IniFileName = {read=FIniFileName, write=FIniFileName};
	__property AnsiString IniSection = {read=FIniSection, write=FIniSection};
	__property TAppBarRegLocation RegLocation = {read=FRegLocation, write=SetRegLocation, default=0};
	__property AnsiString RegKey = {read=FRegKey, write=SetRegKey};
	__property TAppBarRestoreProperties RestoreProperties = {read=FRestoreProperties, write=FRestoreProperties, default=54};
	__property TAppBarRegOptions Options = {read=FOptions, write=FOptions, default=1};
	__property TAppBarStorageType Storage = {read=FStorage, write=FStorage, default=0};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TAppBarRegistrySaver(void) { }
	#pragma option pop
	
};


class DELPHICLASS TAppBarSizing;
class PASCALIMPLEMENTATION TAppBarSizing : public TAppBarPersistent 
{
	typedef TAppBarPersistent inherited;
	
private:
	Word FHorizontalIncrement;
	Word FVerticalIncrement;
	
public:
	__fastcall virtual TAppBarSizing(TAppBar* aAppBar);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Word HorizontalIncrement = {read=FHorizontalIncrement, write=FHorizontalIncrement, default=1};
	__property Word VerticalIncrement = {read=FVerticalIncrement, write=FVerticalIncrement, default=1};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TAppBarSizing(void) { }
	#pragma option pop
	
};


class DELPHICLASS TAppBarSliding;
class PASCALIMPLEMENTATION TAppBarSliding : public TAppBarPersistent 
{
	typedef TAppBarPersistent inherited;
	
private:
	Word FSlideTime;
	
public:
	__fastcall virtual TAppBarSliding(TAppBar* aAppBar);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Word SlideTime = {read=FSlideTime, write=FSlideTime, default=200};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TAppBarSliding(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TAppBarShowBehavior { sbOnFloat, sbShowAlways, sbHideAlways };
#pragma option pop

typedef void __fastcall (__closure *TAppBarDockedEvent)(System::TObject* Sender, TAppBarPlacement NewPlacement);

typedef void __fastcall (__closure *TAppBarDockingEvent)(System::TObject* Sender, TAppBarPlacement &NewPlacement);

typedef void __fastcall (__closure *TAppBarHidingEvent)(System::TObject* Sender, bool &AllowOperation);

typedef void __fastcall (__closure *TAppBarFullScreenAppEvent)(System::TObject* Sender, bool Open);

typedef void __fastcall (__closure *TAppBarWindowArrangeEvent)(System::TObject* Sender, bool Beginning);

class PASCALIMPLEMENTATION TAppBar : public TAppBarAppHookComponent 
{
	typedef TAppBarAppHookComponent inherited;
	
private:
	TAppBarEdges FAllowedEdges;
	bool FAutoHide;
	TAppBarDocking* FDocking;
	bool FDontSlideOnTaskBarWhenAutoHide;
	TAppBarFloatRestrictions* FFloatRestrictions;
	TAppBarPlacement FLastDockingPlace;
	TAppBarPlacement FPlacement;
	TAppBarRegistrySaver* FRegistrySaver;
	TAppBarSizing* FSizing;
	TAppBarSliding* FSliding;
	TAppBarShowBehavior FTaskIcon;
	TAppBarShowBehavior FTitleBar;
	Classes::TNotifyEvent FOnActivate;
	Classes::TNotifyEvent FOnDeactivate;
	Classes::TNotifyEvent FOnClick;
	Classes::TNotifyEvent FOnDblClick;
	TAppBarDockedEvent FOnDocked;
	TAppBarDockingEvent FOnDocking;
	TAppBarDockedEvent FOnDockMove;
	Classes::TNotifyEvent FOnExitSizeMove;
	TAppBarHidingEvent FOnHiding;
	TAppBarHidingEvent FOnUnhiding;
	TAppBarFullScreenAppEvent FOnFullScreenApp;
	Classes::TNotifyEvent FOnOtherAppBarPosChanged;
	Classes::TNotifyEvent FOnUnableToAutoHide;
	TAppBarWindowArrangeEvent FOnWindowArrange;
	bool FAutoHideVisible;
	bool FRegistered;
	bool FMoved;
	bool FFixPlacement;
	TAppBarPlacement FProposedPlacement;
	#pragma pack(push, 1)
	Types::TRect FFloatRect;
	#pragma pack(pop)
	
	#pragma pack(push, 1)
	Types::TRect FMovingRect;
	#pragma pack(pop)
	
	bool FFullScreenAppOpen;
	void __fastcall SetAutoHide(bool Value);
	TAppBarPlacement __fastcall GetPlacement(void);
	void __fastcall SetPlacement(TAppBarPlacement Value);
	void __fastcall SetTaskIcon(TAppBarShowBehavior Value);
	void __fastcall SetTitleBar(TAppBarShowBehavior Value);
	int __fastcall ScreenLeft(void);
	int __fastcall ScreenWidth(void);
	int __fastcall ScreenTop(void);
	int __fastcall ScreenHeight(void);
	void __fastcall GetProposedRect(TAppBarPlacement ProposedPlacement, Types::TRect &rcProposed);
	bool __fastcall AdjustLocationForAutoHide(bool Show, Types::TRect &rc);
	void __fastcall SlideWindow(Types::TRect &rcEnd);
	void __fastcall SetWindowRect(const Types::TRect &Rect);
	Types::TSmallPoint __fastcall GetMessagePosition(void);
	void __fastcall ChangeWindowStyle(bool Moving, const TAppBarPlacement ProposedPlacement);
	bool __fastcall CanHideUnhide(void);
	void __fastcall DoShowHiddenAppBar(bool Show);
	void __fastcall RegisterAppBar(void);
	void __fastcall UnregisterAppBar(void);
	void __fastcall UpdateTimer(void);
	void __fastcall UpdateTaskIcon(void);
	unsigned __fastcall AppBarMessage(int abMessage, const TAppBarPlacement abPlacement, int Param, bool bRect, Types::TRect &RRect);
	void __fastcall AppBarMessage1(int abMessage);
	unsigned __fastcall AppBarMessage2(int abMessage, const TAppBarPlacement abPlacement);
	unsigned __fastcall AppBarMessage3(int abMessage, const TAppBarPlacement abPlacement, int Param);
	void __fastcall AppBarMessage4(int abMessage, const TAppBarPlacement abPlacement, Types::TRect &RRect);
	void __fastcall AppBarMessage5Undock(void);
	
protected:
	virtual void __fastcall WndProc(Messages::TMessage &Message);
	virtual void __fastcall AppMessageBefore(Messages::TMessage &Message, bool &Handled);
	virtual void __fastcall MessageBefore(Messages::TMessage &Message, bool &Handled);
	virtual void __fastcall MessageAfter(Messages::TMessage &Message);
	virtual void __fastcall Loaded(void);
	
public:
	__fastcall virtual TAppBar(Classes::TComponent* aOwner);
	__fastcall virtual ~TAppBar(void);
	virtual void __fastcall UpdateBar(void);
	void __fastcall ShowHiddenAppBar(const bool Show);
	bool __fastcall IsMouseOverAppBar(void);
	__property bool AutoHideVisible = {read=FAutoHideVisible, nodefault};
	
__published:
	__property TAppBarEdges AllowedEdges = {read=FAllowedEdges, write=FAllowedEdges, default=31};
	__property bool AlwaysOnTop = {read=GetTopmost, write=SetTopmost, default=1};
	__property bool AutoHide = {read=FAutoHide, write=SetAutoHide, default=0};
	__property TAppBarDocking* Docking = {read=FDocking, write=FDocking};
	__property bool DontSlideOnTaskBarWhenAutoHide = {read=FDontSlideOnTaskBarWhenAutoHide, write=FDontSlideOnTaskBarWhenAutoHide, default=0};
	__property TAppBarFloatRestrictions* FloatRestrictions = {read=FFloatRestrictions, write=FFloatRestrictions};
	__property TAppBarPlacement LastDockingPlace = {read=FLastDockingPlace, write=FLastDockingPlace, default=1};
	__property TAppBarPlacement Placement = {read=GetPlacement, write=SetPlacement, default=4};
	__property TAppBarRegistrySaver* RegistrySaver = {read=FRegistrySaver, write=FRegistrySaver};
	__property TAppBarSizing* Sizing = {read=FSizing, write=FSizing};
	__property TAppBarSliding* Sliding = {read=FSliding, write=FSliding};
	__property TAppBarShowBehavior TaskIcon = {read=FTaskIcon, write=SetTaskIcon, default=0};
	__property TAppBarShowBehavior TitleBar = {read=FTitleBar, write=SetTitleBar, default=0};
	__property Classes::TNotifyEvent OnActivate = {read=FOnActivate, write=FOnActivate};
	__property Classes::TNotifyEvent OnClick = {read=FOnClick, write=FOnClick};
	__property Classes::TNotifyEvent OnDblClick = {read=FOnDblClick, write=FOnDblClick};
	__property Classes::TNotifyEvent OnDeactivate = {read=FOnDeactivate, write=FOnDeactivate};
	__property TAppBarDockedEvent OnDocked = {read=FOnDocked, write=FOnDocked};
	__property TAppBarDockingEvent OnDocking = {read=FOnDocking, write=FOnDocking};
	__property TAppBarDockedEvent OnDockMove = {read=FOnDockMove, write=FOnDockMove};
	__property Classes::TNotifyEvent OnExitSizeMove = {read=FOnExitSizeMove, write=FOnExitSizeMove};
	__property TAppBarFullScreenAppEvent OnFullScreenApp = {read=FOnFullScreenApp, write=FOnFullScreenApp};
	__property Classes::TNotifyEvent OnOtherAppBarPosChanged = {read=FOnOtherAppBarPosChanged, write=FOnOtherAppBarPosChanged};
	__property Classes::TNotifyEvent OnUnableToAutoHide = {read=FOnUnableToAutoHide, write=FOnUnableToAutoHide};
	__property TAppBarWindowArrangeEvent OnWindowArrange = {read=FOnWindowArrange, write=FOnWindowArrange};
	__property TAppBarHidingEvent OnHiding = {read=FOnHiding, write=FOnHiding};
	__property TAppBarHidingEvent OnUnhiding = {read=FOnUnhiding, write=FOnUnhiding};
};



//-- var, const, procedure ---------------------------------------------------
static const Word UM_RECREATENOTIFY = 0x52d;
static const Word WM_FORMCAPTIONCHANGED = 0x3a59;
static const Word WM_SYSTEMMENUCHANGED = 0x3a60;
static const Word WM_WHATSTHIS = 0x3a61;
static const Word WM_TOPMOSTCHANGEDNOTIFY = 0x3a62;
static const Word WM_APPBARNOTIFY = 0x3a63;
static const Word WM_TRAYICONNOTIFY = 0x3a64;
static const Word WM_RECREATENOTIFY = 0x3a65;
static const Word WM_APPBARSHOWINGCHANGED = 0x3a66;
static const Byte DEFAULT_SLIDE_TIME = 0xc8;
static const Word DEFAULT_DOCK_MAXWIDTH = 0x190;
static const Word DEFAULT_DOCK_MAXHEIGHT = 0x12c;
static const Shortint DEFAULT_DOCK_WIDTH = 0x20;
static const Shortint DEFAULT_DOCK_HEIGHT = 0x20;

}	/* namespace Appbar */
using namespace Appbar;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// AppBar
